#ifndef _COMPILER_H
#define _COMPILER_H

/**
     . 
         {\it  }.
    : -   .

 {\it - (RESTRICT)}   
\begin{verbatim}
{ ,  ,  , }. 
\end{verbatim}
{\it  }  ,    . 
{\it  }  ,    . 
{\it    } (>, <  ..)     
    {\it } ( ).

 {\it   (JOIN)}   
\begin{verbatim}
{ ,  1,  2}.
\end{verbatim}
{\it  } ,     . 
{\it  } ,      . 

      , ,   

{\it  ..     . - .: , 1998. }

        (   
\Ref{QUERY_FNAME}).            
,     .        
  .

 :


\begin{verbatim} 
0 J 1 #0 #1
\end{verbatim}
 
\begin{verbatim} 
R0 JOIN R1 OVER A1
\end{verbatim}
..      1     0  1. 

{\it .}  0          . 
 \# ("")   0  1 ,      
      .


\begin{verbatim} 
0 J 2 #2 1
1 R 3 > 10 #3
\end{verbatim}  
 
\begin{verbatim} 
R2 JOIN (R3 WHERE A3 > 10) OVER A2 
\end{verbatim} 
..      2     2    
     3,      3  ,  10.

{\it .}  0  1          . 
 \# ("")   2  3 ,      
      .   \#   1 
 0-    ,      
     1.

 
\begin{verbatim} 
0 J 1 1 2
1 R 3 > 10 #2
2 R 0 < 20 #1
\end{verbatim}  
 
\begin{verbatim} 
(R2 WHERE A3 > 10) JOIN (R1 WHERE A0 < 20) OVER A1
\end{verbatim} 
..      1        2, 
     3  ,  10,       
  1,      0  ,  20.


\begin{verbatim} 
0 J 1 1 3
1 R 3 > 10 #2
2 R 0 < 20 #1
\end{verbatim}
  :     0     
     3.

     (   -):
{\bf
\begin{verbatim}
<  >::=<  > <   >
<   >::=<  > | <  >
<  >::=R <  > < > <> <>
<  >::=J <  > <> <>
<>::=<  > | #<  >
< >::= > | < | =
<  >::=<  >
<  >::=<  >
<  >::=<  >
\end{verbatim}
}
 : 
\begin{enumerate} 
\item        0  \Ref{ATTRIBUTES_IN_RELATION}-1 .
\item        0  \Ref{RELATIONS_IN_DATABASE}-1 .
\item           0  (2^\Ref{TREE_LEVEL_MAX})-1 .
\end{enumerate}
      (..      ).
@memo  
@name  Compiler
@author (c) 2004 .. , .. 
@version 1.0  \today
@see DatabaseGenerator PlanGenerator
*/

#include "dbgen.h"	/*    */

/*@{*/

/**
    
@name Compiler_Constants
@memo   
*/

/*@{*/

/**
 QUERY_FNAME     {\bf "query txt"},
       .
@memo    
@see cp_CompileQuery
*/
#define QUERY_FNAME	"query.txt"


/**
      (,    ,
       )  (2^\Ref{TREE_LEVEL_MAX})-1.
@memo    
@see QUERY_FNAME cp_CompileQuery
*/
#define TREE_LEVEL_MAX	(4)

/*@}*/

/**
    
@name Compiler_Types
@memo   
*/

/*@{*/

enum _operation {
	JOIN	=0,
	RESTRICT=1,
	SCAN	=2,
	EXCHANGE=3,
	MERGE	=31,
	GATHER	=32,
	SPLIT	=33,
	SCATTER	=34,
	STORE	=4
};

/**
     :

\begin{tabular}{lll}
{\bf N /}	& {\bf }	& {\bf }	\\
1		&	JOIN		&   \\
2		&	RESTRICT	&  \\
3		&	SCAN		&    \\
4		&	MERGE		&     EXCHANGE,    \\
5		&	GATHER		&     EXCHANGE,  ""       \\
6		&	SPLIT		&     EXCHANGE,   ""-"" \\
7		&	SCATTER		&     EXCHANGE,  ""       \\
8		&	STORE		&    
\end{tabular}
@memo    
@see opJOIN_t opRESTRICT_t opSCAN_t opGATHER_t opSPLIT_t opSCATTER_t
*/
typedef enum _operation operation_t;


struct _opJOIN {
	int attribute;
};

/**
      :

\begin{tabular}{lll}
{\bf N /}	& {\bf }		& {\bf }	\\
1		& int attribute &    (   0  \Ref{ATTRIBUTES_IN_RELATION}-1 ) 
\end{tabular}
@memo   
@see opRESTRICT_t opSCAN_t RELATIONS_IN_DATABASE ATTRIBUTES_IN_RELATION
*/
typedef struct _opJOIN opJOIN_t;

enum _theta {
	EQUAL				=0,
	NOT_EQUAL			=1,
	GREATER				=2,
	LESS				=3,
	GREATER_OR_EQUAL	=4,
	LESS_OR_EQUAL		=5
};

/**
   :

\begin{tabular}{cll}
{\bf N /}	& {\bf  }	& {\bf }	\\
1		&	EQUAL		&  \\
2		&	NOT_EQUAL	&    \\
3		&	GREATER		&   \\
4		&	LESS		&   \\
5		&	GREATER_OR_EQUAL	&    \\
6		&	LESS_OR_EQUAL		&   
\end{tabular}
@memo  
@see opRESTRICT_t
*/
typedef enum _theta theta_t; 

struct _opRESTRICT {
	int attribute;
	theta_t theta;
	domain_t literal;
};

/**
     :

\begin{tabular}{lll}
{\bf N /}	& {\bf }		& {\bf }	\\
1		& int attribute			&    (   0  \Ref{ATTRIBUTES_IN_RELATION}-1 ) \\
2		& \Ref{theta_t} theta	&   \\
3		& \Ref{domain_t} literal &   \\
\end{tabular}
@memo   
@see opJOIN_t opSCAN_t ATTRIBUTES_IN_RELATION theta_t domain_t
*/
typedef struct _opRESTRICT opRESTRICT_t;

struct _opSCAN {
	int relation;
};

/**
     :

\begin{tabular}{lll}
{\bf N /}	& {\bf }		& {\bf }	\\
1		& int relation	&  - (   0  \Ref{RELATIONS_IN_DATABASE}-1 )
\end{tabular}
@memo   
@see opJOIN_t opRESTRICT_t RELATIONS_IN_DATABASE
*/
typedef struct _opSCAN opSCAN_t;

typedef tuple_t (* _execute_fn_t)(void *);

/**
 :
\begin{verbatim}
typedef tuple_t (* _execute_fn_t)(void *);
\end{verbatim}
        , 
         
    ,   .
@memo   
@see tuple_t treenode_t reset_fn_t
*/
typedef _execute_fn_t execute_fn_t;

typedef int (* _reset_fn_t)(void *);

/**
 :
\begin{verbatim}
typedef int (* _reset_fn_t)(void *);
\end{verbatim}
        , 
 ,     ,  
 0    ,    
  .
@memo   
@see execute_fn_t treenode_t ErrorCodes
*/
typedef _reset_fn_t reset_fn_t;

struct _treenode {
	operation_t operation;
	void * cargo;
	int fragmentattr;
	fragment_fn_t fragmentfn;
	int ary;
	int card;
	execute_fn_t executefn;
	reset_fn_t resetfn;
	tuple_t result;		
	int isBOF;
	int isEOF;
	struct _treenode * left;
	struct _treenode * right;
};

/**
     :

\begin{tabular}{lll}
{\bf N /}	&	{\bf }	& {\bf }	\\
1		&	\Ref{operation_t} operation	&   \\
2		&	void * cargo				&   (   ) \\
3		&	int fragmentattr			&   ,    \\
4		&	\Ref{fragment_fn_t} fragmentfn &   ,    \\
5		&	int ary						&  ( )   \\
6		&	\Ref{execute_fn_t} executefn &     ,    \\
7		&	\Ref{reset_fn_t} resetfn	&      ,    \\
8		&	\Ref{tuple_t} result		&   -   ,    \\
9		&	int isBOF					& " " (    ,       ) \\
10		&	int isEOF					& " " (    ,       ) \\
11		&	struct _\Ref{treenode_t} * left &	    \\
12		&	struct _\Ref{treenode_t} * right &	   .
\end{tabular}
@memo   
@see operation_t opJOIN_t opRESTRICT_t opSCAN_t opMERGE_t opGATHER_t opSPLIT_t opSCATTER_t cp_CompileQuery fragment_fn_t execute_fn_t 
*/
typedef struct _treenode treenode_t;

/*@}*/


/**
    
@name Compiler_Functions
@memo   
*/

/*@{*/

/**
       
         .
       .
@memo   
@param node	   	
@return SUCCESS       
@see cp_CompileQuery
*/
extern int cp_InitCompiler(int node);

/**
      
      .
       ""     .

,  
\begin{verbatim} 
0 J 1 #0 #1
\end{verbatim}
(     1     0  1)   
  :
\begin{itemize}
\item {\bf :} {=={\it },     1}
\item {\bf  :} {=={\it },    0}
\item {\bf  :} {=={\it },    1}
\end{itemize}
@memo  
@param query     (    -  )
@return          NULL   
@see QUERY_FNAME treenode_t operation_t
*/
extern treenode_t * cp_CompileQuery(char * query);

/*
@memo     JOIN
*/
#define opJOIN(treenode, attr)	((opJOIN_t *) treenode->cargo)->attr

/*
@memo     RESTRICT
*/
#define opRESTRICT(treenode, attr)	((opRESTRICT_t *) treenode->cargo)->attr

/*
@memo     SCAN
*/
#define opSCAN(treenode, attr)	((opSCAN_t *) treenode->cargo)->attr

/*@}*/

/*@}*/

#endif /* _COMPILER_H */