/*
assert   
@memo assert  MPI
@name MPI_Assert_Implementation
@author .. , .. 
@version 1.0
*/

#include "mpiassrt.h"	/*  */
#include "mpi.h"		/*  MPI */
#include <stdio.h>
#include <stdlib.h>


/*@{*/

void _MPI_Assert(void * exp, void * _FILE_, unsigned _LINE_)
{
	int size, rank;

	MPI_Comm_size(MPI_COMM_WORLD, &size);
	MPI_Comm_rank(MPI_COMM_WORLD, &rank);
	printf("Process %d of %d. Assertion failed: %s in file %s, line %d\n", rank, size, exp, _FILE_, _LINE_);
	fflush(stdout); 
	MPI_Barrier(MPI_COMM_WORLD); 
	MPI_Abort(MPI_COMM_WORLD, MPI_ERR_OTHER ); 
	abort(); 
}

/*@}*/